/*
 * @(#)file      SnmpTableInfo.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.9
 * @(#)lastedit  04/05/10
 * 
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package validator;

import java.util.List;

import com.sun.management.snmp.SnmpOidDatabaseSupport;

import com.sun.management.snmp.SnmpVarBindList;
import com.sun.management.snmp.SnmpVarBind;
import com.sun.management.snmp.SnmpOid;

public class SnmpTableInfo {
    private SnmpOid oid;
    private boolean allowEmpty;
    private int expectedNbEntries = -1;
    private List expectedIndexes;
    private boolean strict;
    private int nbcolumns = -1;
    private String description;

    /*Called by XML Parsing */
    SnmpTableInfo() {
    }

    public SnmpTableInfo(SnmpOid oid,
			 String  description,
			 int nbcolumns,
			 boolean allowEmpty,
			 int expectedNbEntries,
			 List expectedIndexes,
			 boolean strict) {
	this.oid = oid;
	this.nbcolumns = nbcolumns;
	this.allowEmpty = allowEmpty;
	this.expectedNbEntries = expectedNbEntries;
	this.expectedIndexes = expectedIndexes;
	this.strict = strict;
	this.description=description;
    }
    
    public SnmpOid getOid() {
	return oid;
    }

    public int getNbColumns() {
	return nbcolumns;
    }

    public boolean isEmptyAllowed() {
	return allowEmpty;
    }
    
    public boolean isStrictIndexes() {
	return strict;
    }
    
    public int getExpectedNbEntries() {
	return expectedNbEntries;
    }

    public List getExpectedIndexes() {
	return expectedIndexes;
    }

    public String getDescription() {
	return description;
    }

    /* Called by XML Parsing */
    
    void setOid(SnmpOid oid) {
	this.oid = oid;
    }

    void setNbColumns(int nbcolumns) {
	this.nbcolumns = nbcolumns;
    }

    void allowEmpty(boolean allowEmpty) {
	this.allowEmpty = allowEmpty;
    }

    void strict(boolean strict) {
	this.strict = strict;
    }

    void setNbEntries(int expectedNbEntries) {
	this.expectedNbEntries = expectedNbEntries;
    }

    void setExpectedIndexes(List expectedIndexes) {
	this.expectedIndexes = expectedIndexes;
    }

    void setDescription(String description) {
	this.description = description;
    }    
}
