/*
 * @(#)file      SnmpProxyHandler.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.7
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
package com.sun.management.snmp.rfc2573.manager.internal.v3proxy;

// Util import
import java.util.Enumeration;

// JMX RI
import com.sun.management.snmp.SnmpInt;
import com.sun.management.snmp.SnmpString;
import com.sun.management.snmp.SnmpNull;
import com.sun.management.snmp.SnmpOid;
import com.sun.management.snmp.SnmpVarBindList;
import com.sun.management.snmp.SnmpVarBind;
import com.sun.management.snmp.SnmpStatusException;
import com.sun.management.snmp.SnmpValue;
import com.sun.management.snmp.SnmpDefinitions;
import com.sun.management.snmp.SnmpStatusException;
import com.sun.management.snmp.SnmpString;
import com.sun.management.snmp.manager.SnmpRequest;
import com.sun.management.snmp.manager.SnmpSession;

// jdmk import
import com.sun.jdmk.TraceManager;
import com.sun.jdmk.trace.Trace;

import com.sun.management.snmp.SnmpOidTableSupport;
import com.sun.management.snmp.EnumRowStatus;

// Contrib import
import com.sun.management.snmp.rfc2573.v3proxy.mib.SNMP_PROXY_MIBOidTable;
import com.sun.management.snmp.rfc2573.manager.internal.v3proxy.SnmpProxyData;

public class SnmpProxyHandler  {
    
    public static void setProxy(SnmpSession session,
				SnmpProxyData data) 
	throws SnmpStatusException {
	SnmpVarBindList list = new SnmpVarBindList();
	
	//Name Index
	SnmpString name = new SnmpString(data.proxyName);
	SnmpOid nameOid = name.toOid();
	long length = data.proxyName.length();
	
	//Type
	SnmpOid oidType = new SnmpOid("1.3.6.1.6.3.14.1.2.1.2");
	SnmpInt type = new SnmpInt(data.type);
	oidType.append(length);
	oidType.append(nameOid);
	if(isDebugOn())
	    debug("setProxy", oidType.toString());
	list.addVarBind(new SnmpVarBind(oidType, type));
	
	//contextEngineId
	SnmpOid oidCtxEngineId = new SnmpOid("1.3.6.1.6.3.14.1.2.1.3");
	if(isDebugOn())
	    debug("setProxy", "Engine Id : " + data.contextEngineId);
	String id = data.contextEngineId.toString();
	String hexa = id.substring(id.indexOf('x') + 1);
	String s = SnmpString.HexToChar(hexa);
	if(isDebugOn())
	    debug("setProxy", "Engine Id : " + "Hexa string is : " + hexa);
	SnmpString ctxEngineId = new
	    SnmpString(s);
	oidCtxEngineId.append(length);
	oidCtxEngineId.append(nameOid);
	if(isDebugOn())
	    debug("setProxy", oidCtxEngineId.toString());
	list.addVarBind(new SnmpVarBind(oidCtxEngineId, ctxEngineId));
	
	//contextName
	SnmpOid oidCtxName = new SnmpOid("1.3.6.1.6.3.14.1.2.1.4");
	SnmpString ctxName = new SnmpString(data.contextName);
	oidCtxName.append(length);
	oidCtxName.append(nameOid);
	if(isDebugOn())
	    debug("setProxy", oidCtxName.toString());
	list.addVarBind(new SnmpVarBind(oidCtxName, ctxName));

	//paramsIn
	SnmpOid oidParamsIn = new SnmpOid("1.3.6.1.6.3.14.1.2.1.5");
	SnmpString paramsIn = new SnmpString(data.paramsIn);
	oidParamsIn.append(length);
	oidParamsIn.append(nameOid);
	if(isDebugOn())
	    debug("setProxy", oidParamsIn.toString());
	list.addVarBind(new SnmpVarBind(oidParamsIn, paramsIn));
	
	//singleOut
	SnmpOid oidSingleOut = new SnmpOid("1.3.6.1.6.3.14.1.2.1.6");
	SnmpString singleOut = new SnmpString(data.singleOut);
	oidSingleOut.append(length);
	oidSingleOut.append(nameOid);
	if(isDebugOn())
	    debug("setProxy", oidSingleOut.toString());
	list.addVarBind(new SnmpVarBind(oidSingleOut, singleOut));
	
	//multipleOut
	SnmpOid oidMultipleOut = new SnmpOid("1.3.6.1.6.3.14.1.2.1.7");
	SnmpString multipleOut = new SnmpString(data.multipleOut);
	oidMultipleOut.append(length);
	oidMultipleOut.append(nameOid);
	if(isDebugOn())
	    debug("setProxy", oidMultipleOut.toString());
	list.addVarBind(new SnmpVarBind(oidMultipleOut, multipleOut));

	//storage
	SnmpOid oidStorage = new SnmpOid("1.3.6.1.6.3.14.1.2.1.8");
	SnmpInt storage = new SnmpInt(data.storageType);
	oidStorage.append(length);
	oidStorage.append(nameOid);
	if(isDebugOn())
	    debug("setProxy", oidStorage.toString());
	list.addVarBind(new SnmpVarBind(oidStorage, storage));
	
	//RowStatus
	SnmpOid oidRowStatus = new SnmpOid("1.3.6.1.6.3.14.1.2.1.9");
	oidRowStatus.append(length);
	oidRowStatus.append(nameOid);
	EnumRowStatus createAndGo = new EnumRowStatus("createAndGo");
	if(isDebugOn())
	    debug("setProxy", oidRowStatus.toString());
	list.addVarBind(new SnmpVarBind(oidRowStatus, 
					createAndGo.toSnmpValue()));
	
	
	// Send the SET request
	SnmpRequest request = session.snmpSetRequest(null, list);
	
	boolean completed = request.waitForCompletion(session.getDefaultPeer().getTimeout());
	if (completed == false) {
	    if (isTraceOn())
		trace("register", "Request timed out: check reachability of agent.\n");
	    throw new SnmpStatusException(SnmpDefinitions.snmpReqTimeout, 
					  0);
	}
	
	// Check the status
	int errorStatus = request.getErrorStatus();
	if (errorStatus != SnmpDefinitions.snmpRspNoError) {
	    if (isTraceOn()) {
		trace("register","************* Error status = " + SnmpRequest.snmpErrorToString(errorStatus));
		trace("register","Error index = " + request.getErrorIndex());
		throw new SnmpStatusException(errorStatus,
					      request.getErrorIndex());
	    }
	} else {
	    if (isDebugOn()) {
		SnmpVarBindList result = request.getResponseVarBindList();
		debug("register","Result: \n" + result.varBindListToString());
	    }
	}
    }

    public static void removeProxy(SnmpSession session,
				   String proxyIndex) 
	throws SnmpStatusException {
	SnmpVarBindList list = new SnmpVarBindList();
	//Name Index
	SnmpString name = new SnmpString(proxyIndex);
	SnmpOid nameOid = name.toOid();
	long length = proxyIndex.length();
	
	//RowStatus
	SnmpOid oidRowStatus = new SnmpOid("1.3.6.1.6.3.14.1.2.1.9");
	EnumRowStatus destroy = new EnumRowStatus("destroy");
	oidRowStatus.append(length);
	oidRowStatus.append(nameOid);
	if(isDebugOn())
	    debug("removeProxy", oidRowStatus.toString());
	list.addVarBind(new SnmpVarBind(oidRowStatus, 
					destroy.toSnmpValue()));

	
	// Send the SET request
	SnmpRequest request = session.snmpSetRequest(null, list);
	
	boolean completed = request.waitForCompletion(session.getDefaultPeer().getTimeout());
	if (completed == false) {
	    if (isTraceOn())
		trace("register", "Request timed out: check reachability of agent.\n");
	    throw new SnmpStatusException(SnmpDefinitions.snmpReqTimeout, 
					  0);
	}
	
	// Check the status
	int errorStatus = request.getErrorStatus();
	if (errorStatus != SnmpDefinitions.snmpRspNoError) {
	    if (isTraceOn()) {
		trace("register","************* Error status = " + SnmpRequest.snmpErrorToString(errorStatus));
		trace("register","Error index = " + request.getErrorIndex());
		throw new SnmpStatusException(errorStatus,
					      request.getErrorIndex());
	    }
	} else {
	    if (isDebugOn()) {
		SnmpVarBindList result = request.getResponseVarBindList();
		debug("register","Result: \n" + result.varBindListToString());
	    }
	}
    }
    
    
    // TRACES & DEBUG
    //---------------
    
    static boolean isTraceOn() {
        return Trace.isSelected(Trace.LEVEL_TRACE, Trace.INFO_SNMP);
    }

    static void trace(String clz, String func, String info) {
        Trace.send(Trace.LEVEL_TRACE, Trace.INFO_SNMP, clz, func, info);
    }

    static void trace(String func, String info) {
        trace(dbgTag, func, info);
    }
    
    static boolean isDebugOn() {
        return Trace.isSelected(Trace.LEVEL_DEBUG, Trace.INFO_SNMP);
    }

    static void debug(String clz, String func, String info) {
        Trace.send(Trace.LEVEL_DEBUG, Trace.INFO_SNMP, clz, func, info);
    }

    static void debug(String clz, String func, Throwable exception) {
        Trace.send(Trace.LEVEL_DEBUG, Trace.INFO_SNMP, clz, func, exception);
    }

    static void debug(String func, String info) {
        debug(dbgTag, func, info);
    }
    
    static void debug(String func, Throwable exception) {
        debug(dbgTag, func, exception);
    }
    
    static String dbgTag = "SnmpProxyHandler"; 
}
