package com.sun.management.snmp.rfc2573.target.mib;
// java imports
//
import java.io.Serializable;
import java.util.Hashtable;

// jmx imports
//
import javax.management.MBeanServer;
import javax.management.ObjectName;
import javax.management.InstanceAlreadyExistsException;

// jdmk imports
//
import com.sun.management.snmp.agent.SnmpMib;
import com.sun.management.snmp.agent.SnmpMibNode;
import com.sun.management.snmp.agent.SnmpMibTable;
import com.sun.management.snmp.agent.SnmpStandardObjectServer;

//Contrib imports
import com.sun.management.snmp.rfc2573.target.SnmpTargetLcd;
/**
 * The class is used for representing "SNMP-TARGET-MIB".
 * You can edit the file if you want to modify the behaviour of the MIB.
 */
public class SNMP_TARGET_MIBImpl extends SNMP_TARGET_MIB {
    SnmpTargetLcd lcd = null;
    /**
     * Default constructor. Initialize the Mib tree.
     */
    public SNMP_TARGET_MIBImpl(SnmpTargetLcd lcd) {
	this.lcd = lcd;
    }
    public SNMP_TARGET_MIBImpl(MBeanServer server, SnmpTargetLcd lcd) {
	this.server = server;
	this.lcd = lcd;
    }
    
    protected Object createSnmpTargetObjectsMBean(String groupName,
						  String groupOid,  
						  ObjectName groupObjname, 
						  MBeanServer server)  {
	
        // Note that when using standard metadata,
        // the returned object must implement the "SnmpTargetObjectsMBean"
        // interface.
        //
        if (server != null) 
            return new SnmpTargetObjectsImpl(this, server, lcd);
        else 
            return new SnmpTargetObjectsImpl(this, lcd);
    }


}
