/*
 * @(#)file      SnmpProxyData.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.6
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
package com.sun.management.snmp.rfc2573.v3proxy;

import com.sun.management.snmp.SnmpEngineId;
import com.sun.management.snmp.rfc2573.target.SnmpParamsData;
import com.sun.management.snmp.rfc2573.target.SnmpTargetData;

public class SnmpProxyData implements Cloneable {
    /**
     * SNMP Request READ type.
     */
    public final static int READ = 1;
    /**
     * SNMP Request WRITE type.
     */
    public final static int WRITE = 2;
    /**
     * SNMP Request TRAP type.
     */
    public final static int TRAP = 3;
    /**
     * SNMP Request INFORM type.
     */
    public final static int INFORM = 4;
    public String proxyName = null;
    public int type = -1;
    public SnmpEngineId contextEngineId = null;
    public String contextName = null;
    public SnmpParamsData paramsIn = null;
    public SnmpTargetData singleOut = null;
    public String multipleOut = null;
    public int storageType = -1;
    public SnmpAgentProxy proxy = null;

    public Object clone() {
	try {
	    return super.clone();
	}catch(CloneNotSupportedException e) {  
	    return null;
	}
    }

    public String toString() {
	return proxyName + "," + 
	    type + "," + 
	    contextEngineId + "," + 
	    contextName + "," + 
	    paramsIn.paramsName + "," + 
	    singleOut.targetName + "," + 
	    multipleOut + "," +
	    storageType;
    }
}
