package com.sun.management.snmp.rfc2573.v3proxy.mib;
// java imports
//
import java.io.Serializable;

// jmx imports
//
import javax.management.MBeanServer;
import com.sun.management.snmp.SnmpString;
import com.sun.management.snmp.SnmpStatusException;

// jdmk imports
//
import com.sun.management.snmp.agent.SnmpMib;

//Contrib imports
import com.sun.management.snmp.rfc2573.target.SnmpTargetLcd;
import com.sun.management.snmp.rfc2573.v3proxy.SnmpProxyLcd;


public class SnmpProxyObjectsImpl extends SnmpProxyObjects {
    /**
     * Constructor for the "SnmpProxyObjects" group.
     * If the group contains a table, the entries created through an SNMP SET will not be registered in JDMK.
     */
    public SnmpProxyObjectsImpl(SnmpMib myMib, 
				SnmpProxyLcd proxyLcd,
				SnmpTargetLcd targetLcd) {
	super(myMib);
        SnmpProxyTable = new TableSnmpProxyTableImpl (myMib, proxyLcd, targetLcd);
    }
    
    /**
     * Constructor for the "SnmpProxyObjects" group.
     * If the group contains a table, the entries created through an SNMP SET will be AUTOMATICALLY REGISTERED in JDMK.
     */
    public SnmpProxyObjectsImpl(SnmpMib myMib, 
				MBeanServer server, 
				SnmpProxyLcd proxyLcd,
				SnmpTargetLcd targetLcd) {
	super(myMib, server);
        SnmpProxyTable = new TableSnmpProxyTableImpl (myMib, 
						      server, 
						      proxyLcd, 
						      targetLcd);
    }
}
