/*
 * @(#)file      IfEntryImpl.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.5
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */

// java import
//
import java.util.Vector;

// RI import
//
import javax.management.MBeanServer;
import javax.management.ObjectName;
import com.sun.management.snmp.SnmpOid;
import com.sun.management.snmp.SnmpInt;
import com.sun.management.snmp.SnmpValue;
import com.sun.management.snmp.SnmpVarBind;
import com.sun.management.snmp.SnmpVarBindList;

// jdmk import
//
import com.sun.management.comm.SnmpAdaptorServer;
import com.sun.management.snmp.agent.SnmpMib;


/**
 * The IfEntryImpl class provides an simple implementation of the "IfEntry".
 * It is used by the "LinkTrapGenerator" for sending SNMP v1 traps. 
 */

public class IfEntryImpl extends IfEntry {

    // MBean properties.
    //
    private String prefix = "ifTable:ifEntry.ifIndex=";
    
    /**
     * Constructor.
     */
    public IfEntryImpl(SnmpMib myMib) {
        super(myMib);
    }

    /**
     * Register this entry in the MBean server.
     */
    public void addInMBeanServer(MBeanServer server) {
        try {
            server.registerMBean(this, new ObjectName(prefix + IfIndex));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

