/*
 * @(#)file      DemoImpl.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.25
 * @(#)lastedit  04/04/07
 *
 * Copyright 2004 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

import javax.management.MBeanServer;
import com.sun.management.snmp.agent.SnmpMib;

/**
 * The class is a real implementation of the "Demo" group defined
 * in the "DEMO-MIB".
 */

public class DemoImpl extends Demo {

    /**
     * Constructors.
     */
    public DemoImpl(SnmpMib myMib) {
    
        super(myMib);
        init();
    }
    
    public DemoImpl(SnmpMib myMib, MBeanServer server) {
    
        super(myMib, server);
        init();
    }
    
    private void init() {
        
        // Initialize the DemoString.
        //
        DemoString = new String("My demo string");

        // Initialize the DemoInteger.
        //
        DemoInteger = new Integer(123);

        // Initialize the DemoOid.
        //
        DemoOid = new String("1.3.6.1.4.1.42");
    }
}
